//----------------------------------------------------------------------------------------
// Analytical solution for supercritical flow test problems
//----------------------------------------------------------------------------------------

#include "test.H"

// True solution for the test problem
void solution_analytic(const real t, const real coord[d_space], real func[d_var])
{
  func[U]=-1.;
  func[V]=0.;
  func[W]=0.;
#ifdef BAROCLINIC_KEY
  func[T]=20.;
  func[S]=35.;
#endif
}

// Analytic solution for the elevation
void solution_analytic_elevation(const real t, const real coord[d_space_2d], real result[])
{
  const real x1[2]={-10., 0.}, x2[2]={-10., 40.}, x3[2]={53.8622, 5.5872}, 
    x4[2]={53.8622, 34.4128}, slope0=0.53886, slope1=0.79893;
  int sign_top, sign_bot;

  if (coord[0]>x3[0])
  {
    sign_top = -(coord[0]-x4[0])*slope1-(coord[1]-x4[1])>0 ? 1 : -1;
    sign_bot = (coord[0]-x3[0])*slope1-(coord[1]-x3[1])>0 ? 1 : -1;
    result[0] = sign_top*sign_bot>0. ? 0.8350436: 0.5273361;
  }
  else
  {
    sign_top = -(coord[0]-x2[0])*slope0-(coord[1]-x2[1])>0 ? 1 : -1;
    sign_bot = (coord[0]-x1[0])*slope0-(coord[1]-x1[1])>0 ? 1 : -1;
    result[0] = sign_top*sign_bot>0. ? 0.250133 : (sign_top>0 ? 0. : 0.5273361);
  }
}
